const express = require('express');

const schoolApp = express.Router();

const libs = `${process.cwd()}/libs`;

const squel = require('squel');

const query = require(`${libs}/middlewares/query`);

const response = require(`${libs}/middlewares/response`);

/**
 * YOU SHALL NOT PASS
 * Esta rota foi desabilitada pois é mais violenta que clube da luta batendo em laranja mecânica
 * A api fica sobrecarregada
 * Pense na cena do elevador de driver mas o elevador é uma bomba de fusão e demora mais que uma luta do DBz
 */
// schoolApp.get('/', (req, res, next) => {
//     req.sql = squel.select().from('escolas')
//         .field('pk_escola_id')
//         .field('nome_entidade', 'name')
//         .field('ano_censo', 'year')
//         .field('fk_cod_estado')
//         .field('fk_cod_municipio');
//     next();
// }, query, response('school'));

// Get a school by it's id
schoolApp.get('/:id', (req, res, next) => {
    req.sql.from('escola')
        .field('cod_entidade', 'pk_escola_id')
        .field('cod_entidade')
        .field('ano_censo')
        .field('fk_municipio_id')
        .field('fk_estado_id')
        .where('cod_entidade = ?', parseInt(req.params.id, 10));
    next();
}, query, response('school'));

// Get all schools from a state
schoolApp.get('/state/:id', (req, res, next) => {
    req.sql.from('escola')
        .field('cod_entidade', 'pk_escola_id')
        .field('cod_entidade')
        .field('ano_censo')
        .field('fk_municipio_id')
        .where('fk_estado_id = ?', parseInt(req.params.id, 10));
    next();
}, query, response('school'));

// Get all schools from a city
schoolApp.get('/city/:id', (req, res, next) => {
    req.sql.from('escola')
        .field('cod_entidade', 'pk_escola_id')
        .field('cod_entidade')
        .field('ano_censo')
        .field('fk_estado_id')
        .where('fk_municipio_id = ?', parseInt(req.params.id, 10));
    next();
}, query, response('school'));

module.exports = schoolApp;
